
/* Python wrapper functions auto-generated by pidl */
#define PY_SSIZE_T_CLEAN 1 /* We use Py_ssize_t for PyArg_ParseTupleAndKeywords */
#include <Python.h>
#include "python/py3compat.h"
#include "includes.h"
#include <pytalloc.h>
#include "librpc/rpc/pyrpc.h"
#include "librpc/rpc/pyrpc_util.h"
#include "bin/default/source4/librpc/gen_ndr/ndr_opendb.h"
#include "bin/default/source4/librpc/gen_ndr/ndr_opendb_c.h"

/*
 * These functions are here to ensure they can be optimized out by
 * the compiler based on the constant input values
 */

static inline unsigned long long ndr_sizeof2uintmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return UINT64_MAX;
	case 4:
		return UINT32_MAX;
	case 2:
		return UINT16_MAX;
	case 1:
		return UINT8_MAX;
	}

	return 0;
}

static inline long long ndr_sizeof2intmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return INT64_MAX;
	case 4:
		return INT32_MAX;
	case 2:
		return INT16_MAX;
	case 1:
		return INT8_MAX;
	}

	return 0;
}

static inline PyObject *ndr_PyLong_FromLongLong(long long v)
{
	if (v > LONG_MAX || v < LONG_MIN) {
		return PyLong_FromLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

static inline PyObject *ndr_PyLong_FromUnsignedLongLong(unsigned long long v)
{
	if (v > LONG_MAX) {
		return PyLong_FromUnsignedLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

#include "librpc/gen_ndr/server_id.h"
static PyTypeObject opendb_entry_Type;
static PyTypeObject opendb_pending_Type;
static PyTypeObject opendb_file_Type;

static PyTypeObject *server_id_Type;
static PyTypeObject *BaseObject_Type;

static PyObject *py_opendb_entry_get_server(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_server;
	py_server = pytalloc_reference_ex(server_id_Type, pytalloc_get_mem_ctx(obj), &object->server);
	return py_server;
}

static int py_opendb_entry_set_server(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->server");
		return -1;
	}
	PY_CHECK_TYPE(server_id_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->server = *(struct server_id *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_opendb_entry_get_stream_id(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_stream_id;
	py_stream_id = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->stream_id);
	return py_stream_id;
}

static int py_opendb_entry_set_stream_id(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->stream_id");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->stream_id));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->stream_id = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->stream_id = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_entry_get_share_access(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_share_access;
	py_share_access = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->share_access);
	return py_share_access;
}

static int py_opendb_entry_set_share_access(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->share_access");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->share_access));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->share_access = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->share_access = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_entry_get_access_mask(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_access_mask;
	py_access_mask = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->access_mask);
	return py_access_mask;
}

static int py_opendb_entry_set_access_mask(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->access_mask");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->access_mask));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->access_mask = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->access_mask = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_entry_get_file_handle(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_file_handle;
	py_file_handle = pytalloc_GenericObject_reference_ex(pytalloc_get_mem_ctx(obj), object->file_handle);
	return py_file_handle;
}

static int py_opendb_entry_set_file_handle(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->file_handle");
		return -1;
	}
	object->file_handle = pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_opendb_entry_get_fd(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_fd;
	py_fd = pytalloc_GenericObject_reference_ex(pytalloc_get_mem_ctx(obj), object->fd);
	return py_fd;
}

static int py_opendb_entry_set_fd(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->fd");
		return -1;
	}
	object->fd = pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_opendb_entry_get_delete_on_close(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_delete_on_close;
	py_delete_on_close = PyInt_FromLong((uint16_t)object->delete_on_close);
	return py_delete_on_close;
}

static int py_opendb_entry_set_delete_on_close(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->delete_on_close");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->delete_on_close));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->delete_on_close = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->delete_on_close = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_entry_get_allow_level_II_oplock(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_allow_level_II_oplock;
	py_allow_level_II_oplock = PyInt_FromLong((uint16_t)object->allow_level_II_oplock);
	return py_allow_level_II_oplock;
}

static int py_opendb_entry_set_allow_level_II_oplock(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->allow_level_II_oplock");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->allow_level_II_oplock));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->allow_level_II_oplock = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->allow_level_II_oplock = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_entry_get_oplock_level(PyObject *obj, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(obj);
	PyObject *py_oplock_level;
	py_oplock_level = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->oplock_level);
	return py_oplock_level;
}

static int py_opendb_entry_set_oplock_level(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_entry *object = (struct opendb_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->oplock_level");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->oplock_level));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->oplock_level = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->oplock_level = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyGetSetDef py_opendb_entry_getsetters[] = {
	{
		.name = discard_const_p(char, "server"),
		.get = py_opendb_entry_get_server,
		.set = py_opendb_entry_set_server,
		.doc = discard_const_p(char, "PIDL-generated element of base type server_id")
	},
	{
		.name = discard_const_p(char, "stream_id"),
		.get = py_opendb_entry_get_stream_id,
		.set = py_opendb_entry_set_stream_id,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "share_access"),
		.get = py_opendb_entry_get_share_access,
		.set = py_opendb_entry_set_share_access,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "access_mask"),
		.get = py_opendb_entry_get_access_mask,
		.set = py_opendb_entry_set_access_mask,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "file_handle"),
		.get = py_opendb_entry_get_file_handle,
		.set = py_opendb_entry_set_file_handle,
		.doc = discard_const_p(char, "PIDL-generated element of base type pointer")
	},
	{
		.name = discard_const_p(char, "fd"),
		.get = py_opendb_entry_get_fd,
		.set = py_opendb_entry_set_fd,
		.doc = discard_const_p(char, "PIDL-generated element of base type pointer")
	},
	{
		.name = discard_const_p(char, "delete_on_close"),
		.get = py_opendb_entry_get_delete_on_close,
		.set = py_opendb_entry_set_delete_on_close,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint8")
	},
	{
		.name = discard_const_p(char, "allow_level_II_oplock"),
		.get = py_opendb_entry_get_allow_level_II_oplock,
		.set = py_opendb_entry_set_allow_level_II_oplock,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint8")
	},
	{
		.name = discard_const_p(char, "oplock_level"),
		.get = py_opendb_entry_get_oplock_level,
		.set = py_opendb_entry_set_oplock_level,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{ .name = NULL }
};

static PyObject *py_opendb_entry_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct opendb_entry, type);
}


static PyTypeObject opendb_entry_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "opendb.entry",
	.tp_getset = py_opendb_entry_getsetters,
	.tp_methods = NULL,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_opendb_entry_new,
};


static PyObject *py_opendb_pending_get_server(PyObject *obj, void *closure)
{
	struct opendb_pending *object = (struct opendb_pending *)pytalloc_get_ptr(obj);
	PyObject *py_server;
	py_server = pytalloc_reference_ex(server_id_Type, pytalloc_get_mem_ctx(obj), &object->server);
	return py_server;
}

static int py_opendb_pending_set_server(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_pending *object = (struct opendb_pending *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->server");
		return -1;
	}
	PY_CHECK_TYPE(server_id_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->server = *(struct server_id *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_opendb_pending_get_notify_ptr(PyObject *obj, void *closure)
{
	struct opendb_pending *object = (struct opendb_pending *)pytalloc_get_ptr(obj);
	PyObject *py_notify_ptr;
	py_notify_ptr = pytalloc_GenericObject_reference_ex(pytalloc_get_mem_ctx(obj), object->notify_ptr);
	return py_notify_ptr;
}

static int py_opendb_pending_set_notify_ptr(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_pending *object = (struct opendb_pending *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->notify_ptr");
		return -1;
	}
	object->notify_ptr = pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_opendb_pending_getsetters[] = {
	{
		.name = discard_const_p(char, "server"),
		.get = py_opendb_pending_get_server,
		.set = py_opendb_pending_set_server,
		.doc = discard_const_p(char, "PIDL-generated element of base type server_id")
	},
	{
		.name = discard_const_p(char, "notify_ptr"),
		.get = py_opendb_pending_get_notify_ptr,
		.set = py_opendb_pending_set_notify_ptr,
		.doc = discard_const_p(char, "PIDL-generated element of base type pointer")
	},
	{ .name = NULL }
};

static PyObject *py_opendb_pending_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct opendb_pending, type);
}


static PyTypeObject opendb_pending_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "opendb.pending",
	.tp_getset = py_opendb_pending_getsetters,
	.tp_methods = NULL,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_opendb_pending_new,
};


static PyObject *py_opendb_file_get_delete_on_close(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_delete_on_close;
	py_delete_on_close = PyInt_FromLong((uint16_t)object->delete_on_close);
	return py_delete_on_close;
}

static int py_opendb_file_set_delete_on_close(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->delete_on_close");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->delete_on_close));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->delete_on_close = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->delete_on_close = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_file_get_open_write_time(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_open_write_time;
	py_open_write_time = ndr_PyLong_FromUnsignedLongLong(object->open_write_time);
	return py_open_write_time;
}

static int py_opendb_file_set_open_write_time(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->open_write_time");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->open_write_time));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->open_write_time = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->open_write_time = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_file_get_changed_write_time(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_changed_write_time;
	py_changed_write_time = ndr_PyLong_FromUnsignedLongLong(object->changed_write_time);
	return py_changed_write_time;
}

static int py_opendb_file_set_changed_write_time(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->changed_write_time");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->changed_write_time));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->changed_write_time = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->changed_write_time = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_file_get_path(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_path;
	py_path = PyString_FromStringOrNULL(object->path);
	return py_path;
}

static int py_opendb_file_set_path(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->path");
		return -1;
	}
	{
		const char *test_str;
		const char *talloc_str;
		PyObject *unicode = NULL;
		if (PyUnicode_Check(value)) {
			unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
			if (unicode == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			test_str = PyBytes_AS_STRING(unicode);
		} else if (PyBytes_Check(value)) {
			test_str = PyBytes_AS_STRING(value);
		} else {
			PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
			return -1;
		}
		talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
		if (unicode != NULL) {
			Py_DECREF(unicode);
		}
		if (talloc_str == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->path = talloc_str;
	}
	return 0;
}

static PyObject *py_opendb_file_get_num_entries(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_num_entries;
	py_num_entries = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->num_entries);
	return py_num_entries;
}

static int py_opendb_file_set_num_entries(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->num_entries");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->num_entries));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_entries = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_entries = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_file_get_entries(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_entries;
	py_entries = PyList_New(object->num_entries);
	if (py_entries == NULL) {
		return NULL;
	}
	{
		int entries_cntr_0;
		for (entries_cntr_0 = 0; entries_cntr_0 < (object->num_entries); entries_cntr_0++) {
			PyObject *py_entries_0;
			py_entries_0 = pytalloc_reference_ex(&opendb_entry_Type, object->entries, &object->entries[entries_cntr_0]);
			PyList_SetItem(py_entries, entries_cntr_0, py_entries_0);
		}
	}
	return py_entries;
}

static int py_opendb_file_set_entries(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->entries");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int entries_cntr_0;
		object->entries = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->entries, PyList_GET_SIZE(value));
		if (!object->entries) { return -1;; }
		talloc_set_name_const(object->entries, "ARRAY: object->entries");
		for (entries_cntr_0 = 0; entries_cntr_0 < PyList_GET_SIZE(value); entries_cntr_0++) {
			if (PyList_GET_ITEM(value, entries_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->entries[entries_cntr_0]");
				return -1;
			}
			PY_CHECK_TYPE(&opendb_entry_Type, PyList_GET_ITEM(value, entries_cntr_0), return -1;);
			if (talloc_reference(object->entries, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, entries_cntr_0))) == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			object->entries[entries_cntr_0] = *(struct opendb_entry *)pytalloc_get_ptr(PyList_GET_ITEM(value, entries_cntr_0));
		}
	}
	return 0;
}

static PyObject *py_opendb_file_get_num_pending(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_num_pending;
	py_num_pending = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->num_pending);
	return py_num_pending;
}

static int py_opendb_file_set_num_pending(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->num_pending");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->num_pending));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_pending = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_pending = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_opendb_file_get_pending(PyObject *obj, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(obj);
	PyObject *py_pending;
	py_pending = PyList_New(object->num_pending);
	if (py_pending == NULL) {
		return NULL;
	}
	{
		int pending_cntr_0;
		for (pending_cntr_0 = 0; pending_cntr_0 < (object->num_pending); pending_cntr_0++) {
			PyObject *py_pending_0;
			py_pending_0 = pytalloc_reference_ex(&opendb_pending_Type, object->pending, &object->pending[pending_cntr_0]);
			PyList_SetItem(py_pending, pending_cntr_0, py_pending_0);
		}
	}
	return py_pending;
}

static int py_opendb_file_set_pending(PyObject *py_obj, PyObject *value, void *closure)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->pending");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int pending_cntr_0;
		object->pending = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->pending, PyList_GET_SIZE(value));
		if (!object->pending) { return -1;; }
		talloc_set_name_const(object->pending, "ARRAY: object->pending");
		for (pending_cntr_0 = 0; pending_cntr_0 < PyList_GET_SIZE(value); pending_cntr_0++) {
			if (PyList_GET_ITEM(value, pending_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->pending[pending_cntr_0]");
				return -1;
			}
			PY_CHECK_TYPE(&opendb_pending_Type, PyList_GET_ITEM(value, pending_cntr_0), return -1;);
			if (talloc_reference(object->pending, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, pending_cntr_0))) == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			object->pending[pending_cntr_0] = *(struct opendb_pending *)pytalloc_get_ptr(PyList_GET_ITEM(value, pending_cntr_0));
		}
	}
	return 0;
}

static PyGetSetDef py_opendb_file_getsetters[] = {
	{
		.name = discard_const_p(char, "delete_on_close"),
		.get = py_opendb_file_get_delete_on_close,
		.set = py_opendb_file_set_delete_on_close,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint8")
	},
	{
		.name = discard_const_p(char, "open_write_time"),
		.get = py_opendb_file_get_open_write_time,
		.set = py_opendb_file_set_open_write_time,
		.doc = discard_const_p(char, "PIDL-generated element of base type NTTIME")
	},
	{
		.name = discard_const_p(char, "changed_write_time"),
		.get = py_opendb_file_get_changed_write_time,
		.set = py_opendb_file_set_changed_write_time,
		.doc = discard_const_p(char, "PIDL-generated element of base type NTTIME")
	},
	{
		.name = discard_const_p(char, "path"),
		.get = py_opendb_file_get_path,
		.set = py_opendb_file_set_path,
		.doc = discard_const_p(char, "PIDL-generated element of base type string")
	},
	{
		.name = discard_const_p(char, "num_entries"),
		.get = py_opendb_file_get_num_entries,
		.set = py_opendb_file_set_num_entries,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "entries"),
		.get = py_opendb_file_get_entries,
		.set = py_opendb_file_set_entries,
		.doc = discard_const_p(char, "PIDL-generated element of base type opendb_entry")
	},
	{
		.name = discard_const_p(char, "num_pending"),
		.get = py_opendb_file_get_num_pending,
		.set = py_opendb_file_set_num_pending,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "pending"),
		.get = py_opendb_file_get_pending,
		.set = py_opendb_file_set_pending,
		.doc = discard_const_p(char, "PIDL-generated element of base type opendb_pending")
	},
	{ .name = NULL }
};

static PyObject *py_opendb_file_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct opendb_file, type);
}

static PyObject *py_opendb_file_ndr_pack(PyObject *py_obj)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_opendb_file);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_opendb_file_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_opendb_file);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_opendb_file);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_opendb_file_ndr_print(PyObject *py_obj)
{
	struct opendb_file *object = (struct opendb_file *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_opendb_file, "opendb_file", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_opendb_file_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_opendb_file_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_opendb_file_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_opendb_file_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject opendb_file_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "opendb.file",
	.tp_getset = py_opendb_file_getsetters,
	.tp_methods = py_opendb_file_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_opendb_file_new,
};

static PyMethodDef opendb_methods[] = {
	{ NULL, NULL, 0, NULL }
};

static struct PyModuleDef moduledef = {
	PyModuleDef_HEAD_INIT,
	.m_name = "opendb",
	.m_doc = "opendb DCE/RPC",
	.m_size = -1,
	.m_methods = opendb_methods,
};
MODULE_INIT_FUNC(opendb)
{
	PyObject *m;
	PyObject *dep_samba_dcerpc_server_id;
	PyObject *dep_talloc;

	dep_samba_dcerpc_server_id = PyImport_ImportModule("samba.dcerpc.server_id");
	if (dep_samba_dcerpc_server_id == NULL)
		return NULL;

	dep_talloc = PyImport_ImportModule("talloc");
	if (dep_talloc == NULL)
		return NULL;

	server_id_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_server_id, "server_id");
	if (server_id_Type == NULL)
		return NULL;

	BaseObject_Type = (PyTypeObject *)PyObject_GetAttrString(dep_talloc, "BaseObject");
	if (BaseObject_Type == NULL)
		return NULL;

	opendb_entry_Type.tp_base = BaseObject_Type;
	opendb_entry_Type.tp_basicsize = pytalloc_BaseObject_size();

	opendb_pending_Type.tp_base = BaseObject_Type;
	opendb_pending_Type.tp_basicsize = pytalloc_BaseObject_size();

	opendb_file_Type.tp_base = BaseObject_Type;
	opendb_file_Type.tp_basicsize = pytalloc_BaseObject_size();

	if (PyType_Ready(&opendb_entry_Type) < 0)
		return NULL;
	if (PyType_Ready(&opendb_pending_Type) < 0)
		return NULL;
	if (PyType_Ready(&opendb_file_Type) < 0)
		return NULL;
#ifdef PY_ENTRY_PATCH
	PY_ENTRY_PATCH(&opendb_entry_Type);
#endif
#ifdef PY_PENDING_PATCH
	PY_PENDING_PATCH(&opendb_pending_Type);
#endif
#ifdef PY_FILE_PATCH
	PY_FILE_PATCH(&opendb_file_Type);
#endif

	m = PyModule_Create(&moduledef);
	if (m == NULL)
		return NULL;

	Py_INCREF((PyObject *)(void *)&opendb_entry_Type);
	PyModule_AddObject(m, "entry", (PyObject *)(void *)&opendb_entry_Type);
	Py_INCREF((PyObject *)(void *)&opendb_pending_Type);
	PyModule_AddObject(m, "pending", (PyObject *)(void *)&opendb_pending_Type);
	Py_INCREF((PyObject *)(void *)&opendb_file_Type);
	PyModule_AddObject(m, "file", (PyObject *)(void *)&opendb_file_Type);
#ifdef PY_MOD_OPENDB_PATCH
	PY_MOD_OPENDB_PATCH(m);
#endif
	return m;

}
